--- php-8.4.18/ext/opcache/jit/ir/ir_ra.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/opcache/jit/ir/ir_ra.c	2026-04-01 04:35:36.010241264 +0000
@@ -3761,14 +3761,13 @@
 {
 	char key[10];
 
-	IR_ASSERT(reg != IR_REG_NONE);
 	if (!ctx->fused_regs) {
 		ctx->fused_regs = ir_mem_malloc(sizeof(ir_strtab));
 		ir_strtab_init(ctx->fused_regs, 8, 128);
 	}
 	memcpy(key, &root, sizeof(ir_ref));
 	memcpy(key + 4, &ref_and_op, sizeof(ir_ref));
-	ir_strtab_lookup(ctx->fused_regs, key, 8, 0x10000000 | reg);
+	ir_strtab_lookup(ctx->fused_regs, key, 8, 0x10000000 | (uint8_t)reg);
 }
 
 static void assign_regs(ir_ctx *ctx)
@@ -3874,93 +3873,88 @@
 										}
 										prev_use_ref = ref;
 									}
-								} else if ((!prev_use_ref || ctx->cfg_map[prev_use_ref] != ctx->cfg_map[ref])
-								 && needs_spill_reload(ctx, ival, ctx->cfg_map[ref], available)) {
-									if (!(use_pos->flags & IR_USE_MUST_BE_IN_REG)
-									 && use_pos->hint != reg
-//									 && ctx->ir_base[ref].op != IR_CALL
-//									 && ctx->ir_base[ref].op != IR_TAILCALL) {
-									 && ctx->ir_base[ref].op != IR_SNAPSHOT
-									 && !needs_spill_load(ctx, ival, use_pos)) {
-										/* fuse spill load (valid only when register is not reused) */
-										reg = IR_REG_NONE;
-										if (use_pos->next
-										 && use_pos->op_num == 1
-										 && use_pos->next->pos == use_pos->pos
-										 && !(use_pos->next->flags & IR_USE_MUST_BE_IN_REG)) {
-											/* Support for R2 = BINOP(R1, R1) */
-											if (use_pos->hint_ref < 0) {
-												ref = -use_pos->hint_ref;
+								} else {
+									if ((!prev_use_ref || ctx->cfg_map[prev_use_ref] != ctx->cfg_map[ref])
+									 && needs_spill_reload(ctx, ival, ctx->cfg_map[ref], available)) {
+										if (!(use_pos->flags & IR_USE_MUST_BE_IN_REG)
+										 && use_pos->hint != reg
+//										 && ctx->ir_base[ref].op != IR_CALL
+//										 && ctx->ir_base[ref].op != IR_TAILCALL) {
+										 && ctx->ir_base[ref].op != IR_SNAPSHOT
+										 && !needs_spill_load(ctx, ival, use_pos)) {
+											/* fuse spill load (valid only when register is not reused) */
+											reg = IR_REG_NONE;
+											if (use_pos->next
+											 && use_pos->op_num == 1
+											 && use_pos->next->pos == use_pos->pos
+											 && !(use_pos->next->flags & IR_USE_MUST_BE_IN_REG)) {
+												/* Support for R2 = BINOP(R1, R1) */
+												if (use_pos->hint_ref < 0) {
+													ref = -use_pos->hint_ref;
+												}
+												ir_set_alocated_reg(ctx, ref, use_pos->op_num, reg);
+												use_pos = use_pos->next;
 											}
-											ir_set_alocated_reg(ctx, ref, use_pos->op_num, reg);
-											use_pos = use_pos->next;
-										}
-									} else {
-										if (top_ival->flags & IR_LIVE_INTERVAL_SPILL_SPECIAL) {
-											reg |= IR_REG_SPILL_SPECIAL;
 										} else {
-											reg |= IR_REG_SPILL_LOAD;
-										}
-										if (ctx->ir_base[ref].op != IR_SNAPSHOT && !(use_pos->flags & IR_PHI_USE)) {
-											uint32_t use_b = ctx->cfg_map[ref];
+											if (top_ival->flags & IR_LIVE_INTERVAL_SPILL_SPECIAL) {
+												reg |= IR_REG_SPILL_SPECIAL;
+											} else {
+												reg |= IR_REG_SPILL_LOAD;
+											}
+											if (ctx->ir_base[ref].op != IR_SNAPSHOT && !(use_pos->flags & IR_PHI_USE)) {
+												uint32_t use_b = ctx->cfg_map[ref];
 
-											if (ir_ival_covers(ival, IR_SAVE_LIVE_POS_FROM_REF(ctx->cfg_blocks[use_b].end))) {
-												ir_bitset_incl(available, use_b);
+												if (ir_ival_covers(ival, IR_SAVE_LIVE_POS_FROM_REF(ctx->cfg_blocks[use_b].end))) {
+													ir_bitset_incl(available, use_b);
+												}
+												prev_use_ref = ref;
 											}
-											prev_use_ref = ref;
 										}
+									} else {
+										/* reuse register without spill load */
 									}
-									if (use_pos->hint_ref < 0
-									 && (old_reg = ir_get_alocated_reg(ctx, -use_pos->hint_ref, use_pos->op_num)) != IR_REG_NONE) {
-										if (top_ival->flags & IR_LIVE_INTERVAL_SPILL_SPECIAL) {
-											reg |= IR_REG_SPILL_SPECIAL;
+
+									if (use_pos->hint_ref < 0) {
+										if (use_pos->flags & IR_PHI_USE) {
+											IR_ASSERT(use_pos->hint_ref < 0);
+											IR_ASSERT(ctx->vregs[-use_pos->hint_ref]);
+											IR_ASSERT(ctx->live_intervals[ctx->vregs[-use_pos->hint_ref]]);
+											if (ctx->live_intervals[ctx->vregs[-use_pos->hint_ref]]->flags & IR_LIVE_INTERVAL_SPILLED) {
+												/* Spilled PHI var is passed through memory */
+												reg = IR_REG_NONE;
+											}
 										} else {
-											reg |= IR_REG_SPILL_LOAD;
-										}
-										if (reg != old_reg) {
 											IR_ASSERT(ctx->rules[-use_pos->hint_ref] & IR_FUSED);
-											ctx->rules[-use_pos->hint_ref] |= IR_FUSED_REG;
-											ir_set_fused_reg(ctx, ref, -use_pos->hint_ref * sizeof(ir_ref) + use_pos->op_num, reg);
-											use_pos = use_pos->next;
-											continue;
+											old_reg = ir_get_alocated_reg(ctx, -use_pos->hint_ref, use_pos->op_num);
+											if ((old_reg != IR_REG_NONE && reg != old_reg) || reg == IR_REG_NONE) {
+												ctx->rules[-use_pos->hint_ref] |= IR_FUSED_REG;
+												ir_set_fused_reg(ctx, ref, -use_pos->hint_ref * sizeof(ir_ref) + use_pos->op_num, reg);
+												use_pos = use_pos->next;
+												continue;
+											}
 										}
+										ref = -use_pos->hint_ref;
 									}
-								} else if (use_pos->flags & IR_PHI_USE) {
-									IR_ASSERT(use_pos->hint_ref < 0);
-									IR_ASSERT(ctx->vregs[-use_pos->hint_ref]);
-									IR_ASSERT(ctx->live_intervals[ctx->vregs[-use_pos->hint_ref]]);
-									if (ctx->live_intervals[ctx->vregs[-use_pos->hint_ref]]->flags & IR_LIVE_INTERVAL_SPILLED) {
-										/* Spilled PHI var is passed through memory */
-										reg = IR_REG_NONE;
-									}
-								} else if (use_pos->hint_ref < 0
-										&& (old_reg = ir_get_alocated_reg(ctx, -use_pos->hint_ref, use_pos->op_num)) != IR_REG_NONE) {
-									if (reg != old_reg) {
-										IR_ASSERT(ctx->rules[-use_pos->hint_ref] & IR_FUSED);
-										ctx->rules[-use_pos->hint_ref] |= IR_FUSED_REG;
-										ir_set_fused_reg(ctx, ref, -use_pos->hint_ref * sizeof(ir_ref) + use_pos->op_num, reg);
-										use_pos = use_pos->next;
-										continue;
-									}
-								} else {
-									/* reuse register without spill load */
-								}
-								if (use_pos->hint_ref < 0) {
-									ref = -use_pos->hint_ref;
 								}
+
 								ir_set_alocated_reg(ctx, ref, use_pos->op_num, reg);
 
 								use_pos = use_pos->next;
 							}
-						} else if (!(top_ival->flags & IR_LIVE_INTERVAL_SPILL_SPECIAL)) {
+						} else {
 							use_pos = ival->use_pos;
 							while (use_pos) {
 								ref = IR_LIVE_POS_TO_REF(use_pos->pos);
-								if (ctx->ir_base[ref].op == IR_SNAPSHOT) {
+								if (ctx->ir_base[ref].op == IR_SNAPSHOT
+								 && !(top_ival->flags & IR_LIVE_INTERVAL_SPILL_SPECIAL)) {
 									IR_ASSERT(use_pos->hint_ref >= 0);
 									/* A reference to a CPU spill slot */
 									reg = IR_REG_SPILL_STORE | IR_REG_STACK_POINTER;
 									ir_set_alocated_reg(ctx, ref, use_pos->op_num, reg);
+								} else if (use_pos->hint_ref < 0 && !(use_pos->flags & IR_PHI_USE)) {
+									IR_ASSERT(ctx->rules[-use_pos->hint_ref] & IR_FUSED);
+									ctx->rules[-use_pos->hint_ref] |= IR_FUSED_REG;
+									ir_set_fused_reg(ctx, ref, -use_pos->hint_ref * sizeof(ir_ref) + use_pos->op_num, IR_REG_NONE);
 								}
 								use_pos = use_pos->next;
 							}
diff '--color=auto' -Naur php-8.4.18/ext/opcache/jit/ir/ir_save.c php-8.4.20RC1/ext/opcache/jit/ir/ir_save.c
--- php-8.4.18/ext/opcache/jit/ir/ir_save.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/opcache/jit/ir/ir_save.c	2026-04-01 04:35:36.010501847 +0000
@@ -18,7 +18,7 @@
 	}
 }
 
-void ir_print_call_conv(uint32_t flags, FILE *f)
+static void ir_print_call_conv(uint32_t flags, FILE *f)
 {
 	switch (flags & IR_CALL_CONV_MASK) {
 		case IR_CC_BUILTIN:
@@ -74,6 +74,38 @@
 		fprintf(f, " __pure");
 	}
 }
+
+void ir_print_func_proto(const ir_ctx *ctx, const char *name, bool prefix, FILE *f)
+{
+	if (ctx->flags & IR_STATIC) {
+		fprintf(f, "static ");
+	}
+	fprintf(f, "func %s%s(",
+		prefix ? "@" : "",
+		name);
+	if (ctx->ir_base[2].op == IR_PARAM) {
+		ir_insn *insn = &ctx->ir_base[2];
+
+		fprintf(f, "%s", ir_type_cname[insn->type]);
+		insn++;
+		while (insn->op == IR_PARAM) {
+			fprintf(f, ", %s", ir_type_cname[insn->type]);
+			insn++;;
+		}
+		if (ctx->flags & IR_VARARG_FUNC) {
+			fprintf(f, ", ...");
+		}
+	} else if (ctx->flags & IR_VARARG_FUNC) {
+		fprintf(f, "...");
+	}
+	fprintf(f, "): %s", ir_type_cname[ctx->ret_type != (ir_type)-1 ? ctx->ret_type : IR_VOID]);
+	ir_print_call_conv(ctx->flags, f);
+	if (ctx->flags & IR_CONST_FUNC) {
+		fprintf(f, " __const");
+	} else if (ctx->flags & IR_PURE_FUNC) {
+		fprintf(f, " __pure");
+	}
+}
 
 static void ir_save_dessa_moves(const ir_ctx *ctx, int b, ir_block *bb, FILE *f)
 {
diff '--color=auto' -Naur php-8.4.18/ext/opcache/jit/ir/ir_sccp.c php-8.4.20RC1/ext/opcache/jit/ir/ir_sccp.c
